// testMFCSTLDlg.cpp : implementation file
//

#include "stdafx.h"
#include "testMFCSTL.h"
#include "testMFCSTLDlg.h"
#include "countData.h"

#include <process.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////

// stuff from Jeff Richter's book so can painlessy switch to _beginthreadex()
// from CreateThread()

typedef unsigned (__stdcall *PTHREAD_START) (void *);

#define chBEGINTHREADEX(psa, cbStack, pfnStartAddr,					\
						pvParam, fdwCreate, pdwThreadID)			\
		((HANDLE) _beginthreadex((void *) (psa),					\
								 (unsigned) (cbStack),				\
								 (PTHREAD_START) (pfnStartAddr),	\
								 (void *) (pvParam),				\
								 (unsigned) (fdwCreate),			\
								 (unsigned *) (pdwThreadID)))

/////////////////////////////////////////////////////////////////////////////

// timer procedure to look at the transfer array on a regular basis and
// update the list with the contents of the array

void CALLBACK EXPORT timerProc(HWND		hWnd,      // handle of CWnd that called SetTimer
							   UINT		nMsg,      // WM_TIMER   
							   UINT		nIDEvent,  // timer identification
							   DWORD	dwTime)    // system time
{
	CWnd	*tempWnd;

	tempWnd = CWnd::FromHandle(hWnd);
	((CTestMFCSTLDlg *)tempWnd)->updateCount();
	((CTestMFCSTLDlg *)tempWnd)->displayStats();
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestMFCSTLDlg dialog

CTestMFCSTLDlg::CTestMFCSTLDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestMFCSTLDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestMFCSTLDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	mfcTime = 0;
	mfcCount = 0;

	stlTime = 0;
	stlCount = 0;

	msCount = 0;
	fileSize = 0;
	filePosition = 0;

	doingMFC = FALSE;
	doingSTL = FALSE;

	stopScan = FALSE;
}

CTestMFCSTLDlg::~CTestMFCSTLDlg()
{
	flushMFCData();
	flushSTLData();
}

void CTestMFCSTLDlg::flushMFCData()
{
	POSITION	pos;

	pos = mfcData.GetStartPosition();
	while(pos != NULL)
	{
		CString		str;
		countData	*cd = NULL;

		mfcData.GetNextAssoc(pos, str, cd);
		delete cd;
	}

	mfcData.RemoveAll();
}

void CTestMFCSTLDlg::flushSTLData()
{
	MAP_STL::iterator	iter;

	for(iter = stlData.begin(); iter != stlData.end(); iter++)
	{
		countData	*cd;

		cd = iter->second;
		delete cd;
	}

	stlData.clear();
}

void CTestMFCSTLDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestMFCSTLDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestMFCSTLDlg, CDialog)
	//{{AFX_MSG_MAP(CTestMFCSTLDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_TEST_MFC, OnButtonTestMfc)
	ON_BN_CLICKED(IDC_BUTTON_TEST_STL, OnButtonTestStl)
	ON_BN_CLICKED(IDC_BUTTON_BROWSE, OnButtonBrowse)
	ON_EN_CHANGE(IDC_EDIT_FILE, OnChangeEditFile)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestMFCSTLDlg message handlers

BOOL CTestMFCSTLDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	SetTimer(1, 100, timerProc);

	enableControls(TRUE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestMFCSTLDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestMFCSTLDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestMFCSTLDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTestMFCSTLDlg::OnButtonBrowse() 
{
	CString	filePath;
	char	*szFilter = _T("Text Files (*.txt)|*.txt||");
	char	*defFilter = "*.txt";

	GetDlgItemText(IDC_EDIT_FILE, filePath);

	CFileDialog	dlg(TRUE, defFilter, filePath, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
					szFilter, this);
	if (dlg.DoModal() == IDOK)
	{
		filePath = dlg.GetPathName();
		SetDlgItemText(IDC_EDIT_FILE, filePath);
	}

	enableControls(TRUE);
}

void CTestMFCSTLDlg::OnCancel() 
{
	if (doingMFC || doingSTL)
	{
		stopScan = TRUE;
		Sleep(1000);		// don't do this in a commercial program, wait for the thread to die properly
	}

	CDialog::OnCancel();
}

void CTestMFCSTLDlg::OnOK() 
{
	if (doingMFC || doingSTL)
	{
		stopScan = TRUE;
		Sleep(1000);		// don't do this in a commercial program, wait for the thread to die properly
	}

	CDialog::OnOK();
}

void CTestMFCSTLDlg::enableControls(int	testFile)
{
	int	fileOK;

	if (testFile)
	{
		CString	str;
		DWORD	attr;

		GetDlgItemText(IDC_EDIT_FILE, str);
		attr = GetFileAttributes(str);
		fileOK = (attr != -1 && !(attr & FILE_ATTRIBUTE_DIRECTORY));
	}
	else
		fileOK = TRUE;

	enableControl(IDC_BUTTON_TEST_MFC, !(doingMFC || doingSTL) && fileOK);
	enableControl(IDC_BUTTON_TEST_STL, !(doingMFC || doingSTL) && fileOK);
	enableControl(IDC_BUTTON_BROWSE, !(doingMFC || doingSTL));
	enableControl(IDC_EDIT_FILE, !(doingMFC || doingSTL));
}

void CTestMFCSTLDlg::OnChangeEditFile() 
{
	enableControls(TRUE);
}

void CTestMFCSTLDlg::OnButtonTestMfc() 
{
	DWORD	threadId;
	HANDLE	hThread;

	GetDlgItemText(IDC_EDIT_FILE, inputFileName);

	// setup progress control

	CProgressCtrl	*pMFC = (CProgressCtrl *)GetDlgItem(IDC_PROGRESS_MFC);
	CStdioFile		file;

	if (file.Open(inputFileName, CFile::modeRead | CFile::typeText))
	{
		fileSize = file.GetLength();
		file.Close();
	}
	else
		fileSize = 0;

	pMFC->SetRange32(0, fileSize);

	// now scan the file on a separate thread

	hThread = chBEGINTHREADEX(NULL,					// default security descriptor
								0,					// default stack size (1Mb)
								doScanThreadMFC,	// start address
								(void *)this,		// pass the UI as the param
								0,					// create normal
								&threadId);
	CloseHandle(hThread);
}

void CTestMFCSTLDlg::OnButtonTestStl() 
{
	DWORD	threadId;
	HANDLE	hThread;

	GetDlgItemText(IDC_EDIT_FILE, inputFileName);

	// setup progress control

	CProgressCtrl	*pSTL = (CProgressCtrl *)GetDlgItem(IDC_PROGRESS_STL);
	CStdioFile		file;

	if (file.Open(inputFileName, CFile::modeRead | CFile::typeText))
	{
		fileSize = file.GetLength();
		file.Close();
	}
	else
		fileSize = 0;

	pSTL->SetRange32(0, fileSize);

	// now scan the file on a separate thread

	hThread = chBEGINTHREADEX(NULL,					// default security descriptor
								0,					// default stack size (1Mb)
								doScanThreadSTL,	// start address
								(void *)this,		// pass the UI as the param
								0,					// create normal
								&threadId);
	CloseHandle(hThread);
}

void CTestMFCSTLDlg::doScanThreadMFC(void	*param)
{
	CTestMFCSTLDlg	*dlg;

	dlg = (CTestMFCSTLDlg *)param;
	if (dlg != NULL)
	{
		dlg->scanThreadMFC();
	}
}

void CTestMFCSTLDlg::doScanThreadSTL(void	*param)
{
	CTestMFCSTLDlg	*dlg;

	dlg = (CTestMFCSTLDlg *)param;
	if (dlg != NULL)
	{
		dlg->scanThreadSTL();
	}
}

void CTestMFCSTLDlg::scanThreadMFC()
{
	doingMFC = TRUE;
	mfcTime = 0;
	mfcCount = 0;

	msCount = 0;

	// open the file and process the contents

	CStdioFile		file;

	if (file.Open(inputFileName, CFile::modeRead | CFile::typeText))
	{
		BOOL	b;

		while(TRUE)
		{
			if (stopScan)
				break;

			CString	s;
			
			b = file.ReadString(s);
			if (!b)
				break;

			// lookup string

			countData	*cd = NULL;

			if (mfcData.Lookup(s, cd))
			{
				// if we know about the string update the count

				cd->addCount(1);
			}
			else
			{
				// otherwise create the string and update the count

				cd = new countData(s, 1);
				mfcData.SetAt(s, cd);
			}

			filePosition = file.GetPosition();
			mfcCount++;
		}
	}

	// discard the data now the test is complete

	flushMFCData();

	doingMFC = FALSE;
}

void CTestMFCSTLDlg::scanThreadSTL()
{
	doingSTL = TRUE;
	stlTime = 0;
	stlCount = 0;

	msCount = 0;

	// open the file and process the contents

	CStdioFile		file;

	if (file.Open(inputFileName, CFile::modeRead | CFile::typeText))
	{
		BOOL	b;

		while(TRUE)
		{
			if (stopScan)
				break;

			CString	s;
			
			b = file.ReadString(s);
			if (!b)
				break;

			// lookup string

			MAP_STL::iterator	iter;

			iter = stlData.find(s);
			if (iter != stlData.end())
			{
				// if we know about the string update the count

				iter->second->addCount(1);
			}
			else
			{
				// otherwise create the string and update the count

				countData	*cd;

				cd = new countData(s, 1);
				stlData[s] = cd;
			}

			filePosition = file.GetPosition();
			stlCount++;
		}
	}

	// discard the data now the test is complete

	flushSTLData();

	doingSTL = FALSE;
}

void CTestMFCSTLDlg::updateCount()
{
	msCount++;
	if (msCount >= 10)
	{
		msCount = 0;
		if (doingMFC)
			mfcTime += CTimeSpan(1);

		if (doingSTL)
			stlTime += CTimeSpan(1);
	}
}

void CTestMFCSTLDlg::enableControl(UINT	id,
								   int	enable)
{
	CWnd	*w;

	w = GetDlgItem(id);
	if (w != NULL)
		w->EnableWindow(enable);
}

void CTestMFCSTLDlg::displayStats()
{
	TCHAR	text[40];

	SetDlgItemInt(IDC_STATIC_MFC_COUNT, mfcCount, FALSE);
	_stprintf(text, _T("%d:%02d:%02d:%02d"), mfcTime.GetDays(), mfcTime.GetHours(), mfcTime.GetMinutes(), mfcTime.GetSeconds());
	SetDlgItemText(IDC_STATIC_MFC_TIME, text);

	SetDlgItemInt(IDC_STATIC_STL_COUNT, stlCount, FALSE);
	_stprintf(text, _T("%d:%02d:%02d:%02d"), stlTime.GetDays(), stlTime.GetHours(), stlTime.GetMinutes(), stlTime.GetSeconds());
	SetDlgItemText(IDC_STATIC_STL_TIME, text);

	if (doingMFC)
	{
		CProgressCtrl	*pMFC = (CProgressCtrl *)GetDlgItem(IDC_PROGRESS_MFC);

		pMFC->SetPos(filePosition);
	}

	if (doingSTL)
	{
		CProgressCtrl	*pSTL = (CProgressCtrl *)GetDlgItem(IDC_PROGRESS_STL);

		pSTL->SetPos(filePosition);
	}

	enableControls(FALSE);
}


