// testMFCSTLDlg.h : header file
//

#if !defined(AFX_TESTMFCSTLDLG_H__3A001758_7DB8_4CE5_98B1_2B82E554AD49__INCLUDED_)
#define AFX_TESTMFCSTLDLG_H__3A001758_7DB8_4CE5_98B1_2B82E554AD49__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// STL template classes

#undef new				// if we don't undefine new some things fail to compile properly
#pragma warning( disable : 4786)
#include <map>			// for STL map usage
#include <set>			// for STL set usage
#pragma warning( default : 4786)

using namespace std;	// for STL map usage

/////////////////////////////////////////////////////////////////////////////
// MFC template classes

#include "afxtempl.h"

/////////////////////////////////////////////////////////////////////////////
// CTestMFCSTLDlg dialog

class countData;

#define MAP_STL		map<CString, countData *>
#define MAP_MFC		CMap<CString, LPCTSTR, countData *, countData *&>

class CTestMFCSTLDlg : public CDialog
{
// Construction
public:
	CTestMFCSTLDlg(CWnd* pParent = NULL);	// standard constructor

	~CTestMFCSTLDlg();

	void updateCount();

	void displayStats();

// Dialog Data
	//{{AFX_DATA(CTestMFCSTLDlg)
	enum { IDD = IDD_TESTMFCSTL_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTestMFCSTLDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CTestMFCSTLDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButtonTestMfc();
	afx_msg void OnButtonTestStl();
	afx_msg void OnButtonBrowse();
	virtual void OnCancel();
	virtual void OnOK();
	afx_msg void OnChangeEditFile();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	void enableControls(int	testFile);

	static void doScanThreadMFC(void	*param);

	static void doScanThreadSTL(void	*param);

	void scanThreadMFC();

	void scanThreadSTL();

	void flushMFCData();

	void flushSTLData();

	void enableControl(UINT	id,
					   int	enable);

private:
	// stats on time keeping etc

	int			doingMFC;
	CTimeSpan	mfcTime;
	DWORD		mfcCount;

	int			doingSTL;
	CTimeSpan	stlTime;
	DWORD		stlCount;

	DWORD		msCount;
	DWORD		fileSize;
	DWORD		filePosition;

	// stuff for reading the file

	CString		inputFileName;
	int			stopScan;

	// the data structures we are comparing

	MAP_STL		stlData;
	MAP_MFC		mfcData;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TESTMFCSTLDLG_H__3A001758_7DB8_4CE5_98B1_2B82E554AD49__INCLUDED_)
